/*******************************************************************************
 * flagindividual.hpp
 * flag pattern individuals with 1-* mapping between genome and rules
 *
 * Copyright (C) 2006 Joacim Thomassen
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or any later version. 
 * (See accompanying file LICENSE.txt or copy at 
 * http://www.gnu.org/copyleft/gpl.html)
 */
#ifndef FLAGINDIVIDUAL_HPP
#define FLAGINDIVIDUAL_HPP

#include <vector>
#include <string>
#include "individual.hpp"
class Cell;
class Rule;
class CellArray;
class SimpleIndividual;
class FlagIndividual;
class FlagIndividual;
class Individual;

extern std::vector<int> seed_genome;

class FlagIndividual : public Individual
{
   protected:
      FlagIndividual(Individual* i);
      Individual* NextIndividual(Individual* i);
   public:
      FlagIndividual( int genome_size, 
	              int phenotype_size, 
		      int development_steps,
		      bool seed_population );
      ~FlagIndividual();
      void GenomeFactory();
      void RuleFactory();
      void Mutate(); 
      void Develop(); 
      void Evaluate();
      Individual* Clone();
      void InitializeBoard();
};

#endif
