/*******************************************************************************
 * rule.cpp
 * class representing the rule objects assosiated with individuals and
 * cellcolletions during development
 *
 * Copyright (C) 2006 Joacim Thomassen
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or any later version. 
 * (See accompanying file LICENSE.txt or copy at 
 * http://www.gnu.org/copyleft/gpl.html)
 */

#ifndef RULE_HPP
#define RULE_HPP

#include <vector>

class Rule
{
   private:
      int m_action;
      int m_c;
      int m_n;
      int m_s;
      int m_e;
      int m_w;
      
      int legality;
      Rule() {};
   public:

      Rule(int action, 
	   int center, 
	   int north, 
	   int south, 
	   int east, 
	   int west);
      ~Rule();

      bool IsLegal();
      double RuleFitness();

      bool Match(Cell* c, Cell* n, Cell* s, Cell* e, Cell* w);
      int  GetAction();
      void ToString();
};


#endif
