/* FIXME: THIS FILE IS DEPRECATED, ONLY USE NEUTRAL & FLAG INDIVIDULAS FOR KNOW 
 * IT WILL COMPILE BUT MIGHT NOT WORK AS INTENDED AS IT'S NOT UP TO DATE */
/*******************************************************************************
 * simpleindividual.cpp
 * individuals with 1-1 mapping between genome and rules 
 *
 * Copyright (C) 2006 Joacim Thomassen
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or any later version. 
 * (See accompanying file LICENSE.txt or copy at 
 * http://www.gnu.org/copyleft/gpl.html)
 */

/* for srand() and rand(), use GNU Scientific lib. for better
 * and faster number generator when optimizing */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <iostream>
#include <typeinfo>
#include "simpleindividual.hpp"
#include "individual.hpp"
#include "cell.hpp"
#include "rule.hpp"

//#define SIMPLE_INDIVIDUAL_DEBUG(x)
#define SIMPLE_INDIVIDUAL_DEBUG(x) x

SimpleIndividual::SimpleIndividual( int genome_size, 
                                    int phenotype_size, 
	 			    int development_steps, 
				    bool seed_population )
   : Individual(genome_size, phenotype_size, development_steps, seed_population)
{

   GenomeFactory();
   m_board = new CellArray(m_rows, m_cols);
   m_board->SetType(0,1,Cell::TYPE_BLACK);
}

SimpleIndividual::SimpleIndividual(Individual* i)
   : Individual(i)
{
   m_board = new CellArray(m_rows, m_cols);
   m_board->SetType(0,1,Cell::TYPE_BLACK);
}

Individual* SimpleIndividual::NextIndividual(Individual* i)
{
   return new SimpleIndividual(i);
}

void SimpleIndividual::GenomeFactory()
{
   SIMPLE_INDIVIDUAL_DEBUG(std::cout 
	     << "Simple GenomeFactory created Individual @" << this << std::endl
	     << "Type: " << typeid(*this).name() 
	     << ", Genome_size: " << m_genome_size << std::endl);
   SIMPLE_INDIVIDUAL_DEBUG(std::cout << "My genome: ");
   
   /* make random genome for individual */
   for (int i = 0 ; i < m_genome_size ; i++ ) {
      int gene = rand()%8+1;
      m_genome.push_back(gene);
      SIMPLE_INDIVIDUAL_DEBUG(std::cout << gene << " ");
   }
   SIMPLE_INDIVIDUAL_DEBUG(std::cout << std::endl);
}

/* Map genom into rules */
void SimpleIndividual::RuleFactory()
{
   std::cout << typeid(*this).name() 
	     << " entering SIMPLE RuleFactory:" << std::endl;
   // flush previous rules in individual
   // Remember to delete old rules
   m_rules.clear();
   
   // produce new rules from genome
   int ruleNum = 0;
   int genomeLength = m_genome.size();
   int numRules = genomeLength/6;
   

   std::cout << "Creating " << numRules << " of length 6 from length " 
             << genomeLength << std::endl;

   for (ruleNum = 0; ruleNum < numRules ; ruleNum ++) {
      m_rules.push_back(new Rule(m_genome[ruleNum*6+0],
                                 m_genome[ruleNum*6+1],
                                 m_genome[ruleNum*6+2],
                                 m_genome[ruleNum*6+3],
                                 m_genome[ruleNum*6+4],
                                 m_genome[ruleNum*6+5])
	    );
   }
}

#define DEVELOP_DEBUG(x) 
//#define DEVELOP_DEBUG(x) x

/* Develop individual from genotype to phenotype */
void SimpleIndividual::Develop()
{
   DEVELOP_DEBUG(std::cout << "Developing individual " << this << std::endl);
      
   // Copy the board for next development stage
   CellArray* nextBoard = new CellArray(m_rows, m_cols);

   DEVELOP_DEBUG(std::cout << "Start development cycle" 
			   << ToString() << std::endl);
   for (int i = 0; i < m_rows; i++)
   {
      for (int j = 0; j < m_cols; j++) 
      {
	 CellCollection* c = m_board->CreateCellCollection(i,j);
	 //std::cout << "Board:\n" << m_board->ToString()  << std::endl;
	 DEVELOP_DEBUG(std::cout << "Board:\n" << ToString()  << std::endl);
	    
	 std::vector<Rule*>::iterator ruleIt;
	 for(ruleIt = m_rules.begin() ; ruleIt != m_rules.end() ; ++ruleIt) {
	    c->AddRule(*ruleIt);
	 }
         nextBoard->SetType(i,j,c->Evaluate(0));
      }
     m_board = nextBoard;
   }
   DEVELOP_DEBUG(std::cout << "Done development cycle\n" 
			   << ToString()  << std::endl);
}

#define EVALUATE_DEBUG(x) 
//#define EVALUATE_DEBUG(x) x
void SimpleIndividual::Evaluate()
{
   if (m_fitness < 0.0)
   {
      bool legal = false;
      m_fitness = 0.1;

      // Generate rules from genome
      this->RuleFactory();
      // Suppress illegal rules, decrement m_fitness
      std::vector<Rule*>::iterator ruleIt;
      for(ruleIt = m_rules.begin() ; ruleIt != m_rules.end() ; ++ruleIt)
      {
	 if((*ruleIt)->IsLegal())
	 {
	    m_fitness += 1.0;
	    legal = true;
	    
	    std::cout << "Legal rule: ";
	    (*ruleIt)->ToString();
	 }
	 else 
	 { 
	    m_fitness -= 1.5;
	    legal = false;
	 }
	 // TEST: Fitness feedback on rules, convergence too slow.
	 m_fitness += (*ruleIt)->RuleFitness();
      }
   
      // ONLY RUN DEVELOPMENT ON LEGAL RULES !
      if (legal)
      {
	 // Run evaluation by doing development etc.
	 for (int i = 0; i < 20; i++) 
	 {
	    EVALUATE_DEBUG(std::cout << "Develop Individual @" << this 
		      << " step:" << i << std::endl);
	    Develop(); 
	 }
	 for ( int i = 0 ; i < m_rows ; i++ ) {
	   for ( int j = 0 ; j < m_cols ; j++ ) {
	      if ( (i+j)%2 == 0) {
		if (m_board->GetType(i,j) == Cell::TYPE_WHITE) {
		   m_fitness+=10.0;
		}
	      }
	      else {
		if (m_board->GetType(i,j) == Cell::TYPE_BLACK) {
		   m_fitness+=10.0;
		}
	      }
	   }
	 }
      }
      std::cout << "New Fitness of Individual @" << this << ": "
             << m_fitness << std::endl;
   }
}

//Individual* SimpleIndividual::Mutate()
void SimpleIndividual::Mutate()
{
   std::cout << this << " of type " << typeid(*this).name() 
	     << " entering SIMPLE Mutate:" << std::endl;
   int mutationPoint, newGene, nmbrOfMPoints, thresholdFitness;
   /* mutationrate changes to fitness score
    * possible number of mutation points 1-23
    */
   thresholdFitness = 32; // DON'T SET HERE!
   if (m_fitness < thresholdFitness)
   {
      nmbrOfMPoints = rand()%(m_genome.size()-1)+1;
   }
   else
   {
      nmbrOfMPoints = rand()%3+1;
   }
   for (int i = 0; i < nmbrOfMPoints; i++)
   {
      mutationPoint = rand()%m_genome.size();
      newGene = rand()%8+1;
      m_genome[mutationPoint] = newGene;
   }
   //return NextIndividual(this);
}

Individual* SimpleIndividual::Clone()
{
   std::cout << this << " of type " << typeid(*this).name() 
	     << " entering universal Clone:" << std::endl;
   //return new Individual(*this);
   return NextIndividual(this);
}
