#! /bin/bash
# extract_development_data.sh
# script which extracts graph data from the development part of a Exploreed .log
# file the exploration must be run with output=5 set in exploreed.conf
#
# Copyright (C) 2006 Joacim Thomassen
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or any later version. 
# (See accompanying file LICENSE.txt or copy at 
# http://www.gnu.org/copyleft/gpl.html)

# rule_size hardcoded to 6 (unlikely to change, but can be read from .logfile
# like the genome_size

while [ $# != 0 ]
do
   #echo "Extracting relevant data from:" $1 "==>" ${1%.*}.data 
   echo "Extracting relevant data from:" $1 "==>" types_proliferation.data 
   # calculate number of rules
   #rules=`head $1 | grep 'genome_size' |awk 'BEGIN {FS=" +"} {print $2}'| awk 'BEGIN {FS=" "} {print $1/6}'`
   #relevant_lines=$((rules+3))
   #grep -A $relevant_lines 'Development.step:' $1 |  
   grep -A 7 'Development_step:' $1 |  
   awk 'BEGIN {FS=" ";RS="\n"} {$1="";print}' |  
   ##awk 'BEGIN {FS="\n";RS="\n\n+"} {print $1,$2, $3, $4}' > ${1%.*}.data 
   awk 'BEGIN {FS="\n";RS="\n\n+"i;OFS=" "} {$1 = $1;print $0}' > types_proliferation.data 
   shift
done
