# plot_rule_activity.gp for exploreed
#
# Copyright (C) 2006 Joacim Thomassen
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or any later version. 
# (See accompanying file LICENSE.txt or copy at 
# http://www.gnu.org/copyleft/gpl.html)

set terminal postscript eps enhanced color
set output "rule_activity.eps"
#set terminal X11
show output

set multiplot
set grid 

set mxtics
set xlabel "Utviklingstrinn" font "sans, 30pt"
set xrange [-1:100]

set ytics 0,1,16 
set ytics nomirror
set ylabel "Regel nummer" font "sans, 30pt"
set yrange [-1:17]

set y2tics nomirror
set y2label "Antall aktive regler" font "sans, 30pt"
#set y2range [0:*] # autoscaling, gitt opp!
set y2range [0:85] 

#Plot cell type proliferation during development 
set key 91,16.6
plot "types_proliferation.data" using 1:7 title "regelaktivitet" axes x1y2 with line
set key 91,16.2
plot "types_proliferation.data" using 1:8 title "regel" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:9 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:10 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:11 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:12 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:13 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:14 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:15 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:16 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:17 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:18 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:19 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:20 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:21 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:22 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
plot "types_proliferation.data" using 1:23 title "" axes x1y1 with points pointsize 0.5 pt 6 lt 3
