# plot_type-proliferation.gp for exploreed
#
# Copyright (C) 2006 Joacim Thomassen
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or any later version. 
# (See accompanying file LICENSE.txt or copy at 
# http://www.gnu.org/copyleft/gpl.html)

set terminal postscript eps enhanced color
set output "type_proliferation.eps"
#set terminal X11
show output

set multiplot
set mxtics
set mytics
set xlabel "Utviklingstrinn" font "sans, 30pt"
set ylabel "Antall celler" font "sans, 30pt"
#set yrange [0:256]
#set yrange [0:1024]
set yrange [0:64]
set grid 

#Plot cell type proliferation during development 
#set key 90,250
#set key 10,980
set key 18, 62
plot "types_proliferation.data" using 1:2 title "Sort" axes x1y1 with line lt -1 lw 1.5
#set key 90,240
#set key 10,940
set key 18, 58 
plot "types_proliferation.data" using 1:3 title "Hvit" axes x1y1 with line lt 4 lw 2.5 
#set key 90,230
#set key 10,900
set key 18, 58 
plot "types_proliferation.data" using 1:4 title "Roed" axes x1y1 with line lt 1 lw 2.0
#set key 90,220
#set key 10,860
set key 18, 56 
plot "types_proliferation.data" using 1:5 title "Blaa" axes x1y1 with line lt 3 lw 2.0
#set key 90,210
#set key 10,820
set key 18, 54 
plot "types_proliferation.data" using 1:6 title "Groenn" axes x1y1 with line lt 2 lw 2.0
