#! /bin/bash
# publish_report.sh for exploreed
#
# Copyright (C) 2006 Joacim Thomassen
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or any later version. 
# (See accompanying file LICENSE.txt or copy at 
# http://www.gnu.org/copyleft/gpl.html)
#
# requires: pdfjam, sblock.c, epstopdf, gnuplot, extract_development_data.sh, 
# plot_type-proliferation.gp 
if [ $# == 0 ]
then
   echo "You must specify an exploration log file"
   exit
fi
#sblock
if [ -d "output" ]
then
   rm -fr output
fi
mkdir output
if [ -e "sblock" ]
then
   rm sblock
fi
gcc sblock.c -o sblock
./sblock $1 16 16 
for i in output/types_0*.eps;do epstopdf $i;done
pdfjoin output/types_0*.pdf --paper a4paper --orient landscape --outfile output/types_joined.pdf
pdfnup output/types_joined.pdf --paper a4paper --orient landscape --frame true --nup 5x4 --outfile output/types_published.pdf
./extract_development_data.sh $1
gnuplot plot_type-proliferation.gp
epstopdf type_proliferation.eps
gnuplot plot_rule_activity.gp
epstopdf rule_activity.eps
pdfjoin type_proliferation.pdf rule_activity.pdf --paper a4paper --orient landscape --outfile graphs_joined.pdf
pdfnup graphs_joined.pdf --paper a4paper --orient landscape --nup 2x1 --outfile graphs_published.pdf
pdfjoin graphs_published.pdf output/types_published.pdf --paper a4paper --orient landscape --outfile exploration_published.pdf
