/*******************************************************************************
 * xmlparser.hpp
 * simple parser using tinyxml to parse the content of exploreed.conf 
 *
 * Copyright (C) 2006 Joacim Thomassen
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or any later version. 
 * (See accompanying file LICENSE.txt or copy at 
 * http://www.gnu.org/copyleft/gpl.html)
 */

#ifndef XMLPARSER_HPP
#define XMLPARSER_HPP

#include <string>
#include <vector>
#include "config.hpp"
#include "tinyxml/tinyxml.h"

// Represent the configuration file
class Xmlparser
{
   private:
      const std::string m_configfile;
      Xmlparser();
   public:
      Xmlparser(const std::string& config);
      std::vector<Config> ImportConfig(); 
      std::vector<Run> ImportRun(); 
      Config nodeToExploration(TiXmlElement* exploration);
      Run nodeToRun(TiXmlElement* exploration);
};

#endif
